Apex: disables vfio-pci for baremetal fdio
[releng.git] / jjb / apex / apex-deploy.sh
1 #!/bin/bash
2 set -o errexit
3 set -o nounset
4 set -o pipefail
5
6 APEX_PKGS="common undercloud" # removed onos for danube
7 IPV6_FLAG=False
8
9 # log info to console
10 echo "Starting the Apex virtual deployment."
11 echo "--------------------------------------------------------"
12 echo
13
14 if ! rpm -q wget > /dev/null; then
15   sudo yum -y install wget
16 fi
17
18 if [[ "$BUILD_DIRECTORY" == *verify* || "$BUILD_DIRECTORY" == *promote* ]]; then
19     # Build is from a verify, use local build artifacts (not RPMs)
20     cd $WORKSPACE/../${BUILD_DIRECTORY}
21     WORKSPACE=$(pwd)
22     echo "WORKSPACE modified to $WORKSPACE"
23     cd $WORKSPACE/ci
24 elif [[ ! "$ARTIFACT_NAME" == "latest" ]]; then
25     # if artifact name is passed the pull a
26     # specific artifact from artifacts.opnfv.org
27     # artifact specified should be opnfv-apex-<version>.noarch.rpm
28     RPM_INSTALL_PATH=$GS_URL
29     RPM_LIST=$RPM_INSTALL_PATH/$ARTIFACT_NAME
30 else
31     # Use latest RPMS
32     if [[ $BUILD_DIRECTORY == *apex-build* ]]; then
33       # Triggered from a daily so RPMS should be in local directory
34       BUILD_DIRECTORY=$WORKSPACE/../$BUILD_DIRECTORY
35       echo "BUILD DIRECTORY modified to $BUILD_DIRECTORY"
36
37       if [[ -f ${BUILD_DIRECTORY}/../opnfv.properties ]]; then
38         # if opnfv.properties exists then use the
39         # local build. Source the file so we get local OPNFV vars
40         source ${BUILD_DIRECTORY}/../opnfv.properties
41         RPM_INSTALL_PATH=${BUILD_DIRECTORY}/noarch
42         RPM_LIST=$RPM_INSTALL_PATH/$(basename $OPNFV_RPM_URL)
43       else
44         echo "BUILD_DIRECTORY is from a daily job, so will not use latest from URL"
45         echo "Check that the slave has opnfv.properties in $BUILD_DIRECTORY"
46         exit 1
47       fi
48     else
49       # use the latest from artifacts.opnfv.org
50       # get the latest.properties to get the link to the latest artifact
51       if ! wget -O $WORKSPACE/opnfv.properties http://$GS_URL/latest.properties; then
52         echo "ERROR: Unable to find latest.properties at ${GS_URL}...exiting"
53         exit 1
54       fi
55       # source the file so we get OPNFV vars
56       source opnfv.properties
57       RPM_INSTALL_PATH=$(echo "http://"$OPNFV_RPM_URL | sed 's/\/'"$(basename $OPNFV_RPM_URL)"'//')
58       RPM_LIST=${RPM_INSTALL_PATH}/$(basename $OPNFV_RPM_URL)
59     fi
60 fi
61
62 if [ -z "$DEPLOY_SCENARIO" ]; then
63   echo "Deploy scenario not set!"
64   exit 1
65 elif [[ "$DEPLOY_SCENARIO" == *gate* ]]; then
66   echo "Detecting Gating scenario..."
67   if [ -z "$GERRIT_EVENT_COMMENT_TEXT" ]; then
68     echo "ERROR: Gate job triggered without comment!"
69     exit 1
70   else
71     DEPLOY_SCENARIO=$(echo ${GERRIT_EVENT_COMMENT_TEXT} | grep start-gate-scenario | grep -Eo 'os-.*$')
72     if [ -z "$DEPLOY_SCENARIO" ]; then
73       echo "ERROR: Unable to detect scenario in Gerrit Comment!"
74       echo "Format of comment to trigger gate should be 'start-gate-scenario: <scenario>'"
75       exit 1
76     else
77       echo "Gate scenario detected: ${DEPLOY_SCENARIO}"
78     fi
79   fi
80 fi
81
82 # use local build for verify and promote
83 if [[ "$BUILD_DIRECTORY" == *verify* || "$BUILD_DIRECTORY" == *promote* ]]; then
84     if [ ! -e "${WORKSPACE}/build/lib" ]; then
85       ln -s ${WORKSPACE}/lib ${WORKSPACE}/build/lib
86     fi
87     DEPLOY_SETTINGS_DIR="${WORKSPACE}/config/deploy"
88     NETWORK_SETTINGS_DIR="${WORKSPACE}/config/network"
89     DEPLOY_CMD="$(pwd)/deploy.sh"
90     RESOURCES="${WORKSPACE}/.build/"
91     CONFIG="${WORKSPACE}/build"
92     LIB="${WORKSPACE}/lib"
93     # Make sure python34 deps are installed
94     for dep_pkg in epel-release python34 python34-PyYAML python34-setuptools; do
95       if ! rpm -q ${dep_pkg} > /dev/null; then
96         if ! sudo yum install -y ${dep_pkg}; then
97           echo "Failed to install ${dep_pkg}"
98           exit 1
99         fi
100       fi
101     done
102
103     # Make sure jinja2 is installed
104     for python_pkg in jinja2; do
105       if ! python3.4 -c "import $python_pkg"; then
106         echo "$python_pkg package not found for python3.4, attempting to install..."
107         if ! sudo easy_install-3.4 $python_pkg; then
108           echo -e "Failed to install $python_pkg package for python3.4"
109           exit 1
110         fi
111       fi
112     done
113
114     # Make sure ipxe-roms-qemu package is updated to latest.
115     # This package is needed for multi virtio nic PXE boot in virtual environment.
116     sudo yum update -y ipxe-roms-qemu
117
118     if [ -z ${PYTHONPATH:-} ]; then
119         export PYTHONPATH=${WORKSPACE}/lib/python
120     else
121         export PYTHONPATH=$PYTHONPATH:${WORKSPACE}/lib/python
122     fi
123 # use RPMs
124 else
125     # find version of RPM
126     VERSION_EXTENSION=$(echo $(basename $RPM_LIST) | grep -Eo '[0-9]+\.[0-9]+-[0-9]{8}')
127     # build RPM List which already includes base Apex RPM
128     for pkg in ${APEX_PKGS}; do
129         RPM_LIST+=" ${RPM_INSTALL_PATH}/opnfv-apex-${pkg}-${VERSION_EXTENSION}.noarch.rpm"
130     done
131
132     # remove old / install new RPMs
133     if rpm -q opnfv-apex > /dev/null; then
134       INSTALLED_RPMS=$(rpm -qa | grep apex)
135       if [ -n "$INSTALLED_RPMS" ]; then
136         sudo yum remove -y ${INSTALLED_RPMS}
137       fi
138     fi
139
140     if ! sudo yum install -y $RPM_LIST; then
141       echo "Unable to install new RPMs: $RPM_LIST"
142       exit 1
143     fi
144
145     DEPLOY_CMD=opnfv-deploy
146     DEPLOY_SETTINGS_DIR="/etc/opnfv-apex/"
147     NETWORK_SETTINGS_DIR="/etc/opnfv-apex/"
148     RESOURCES="/var/opt/opnfv/images"
149     CONFIG="/var/opt/opnfv"
150     LIB="/var/opt/opnfv/lib"
151 fi
152
153 # set env vars to deploy cmd
154 DEPLOY_CMD="CONFIG=${CONFIG} RESOURCES=${RESOURCES} LIB=${LIB} ${DEPLOY_CMD}"
155
156 if [ "$OPNFV_CLEAN" == 'yes' ]; then
157   if sudo test -e '/root/inventory/pod_settings.yaml'; then
158     clean_opts='-i /root/inventory/pod_settings.yaml'
159   else
160     clean_opts=''
161   fi
162   if [[ "$BUILD_DIRECTORY" == *verify* || "$BUILD_DIRECTORY" == *promote* ]]; then
163     sudo CONFIG=${CONFIG} LIB=${LIB} ./clean.sh ${clean_opts}
164   else
165     sudo CONFIG=${CONFIG} LIB=${LIB} opnfv-clean ${clean_opts}
166   fi
167 fi
168
169 if echo ${DEPLOY_SCENARIO} | grep ipv6; then
170   IPV6_FLAG=True
171   DEPLOY_SCENARIO=$(echo ${DEPLOY_SCENARIO} |  sed 's/-ipv6//')
172   echo "INFO: IPV6 Enabled"
173 fi
174
175 echo "Deploy Scenario set to ${DEPLOY_SCENARIO}"
176 DEPLOY_FILE="${DEPLOY_SETTINGS_DIR}/${DEPLOY_SCENARIO}.yaml"
177
178 if [ ! -e "$DEPLOY_FILE" ]; then
179   echo "ERROR: Required settings file missing: Deploy settings file ${DEPLOY_FILE}"
180 fi
181
182 if [[ "$JOB_NAME" == *virtual* ]]; then
183   # settings for virtual deployment
184   DEPLOY_CMD="${DEPLOY_CMD} -v"
185   if [[ "${DEPLOY_SCENARIO}" =~ fdio|ovs ]]; then
186     DEPLOY_CMD="${DEPLOY_CMD} --virtual-default-ram 14 --virtual-compute-ram 8"
187   fi
188   if [[ "$JOB_NAME" == *csit* ]]; then
189     DEPLOY_CMD="${DEPLOY_CMD} -e csit-environment.yaml"
190   fi
191   if [[ "$JOB_NAME" == *promote* ]]; then
192     DEPLOY_CMD="${DEPLOY_CMD} --virtual-computes 2"
193   fi
194 else
195   # settings for bare metal deployment
196   NETWORK_SETTINGS_DIR="/root/network"
197   INVENTORY_FILE="/root/inventory/pod_settings.yaml"
198
199 # (trozet) According to FDS folks uio_pci_generic works with UCS-B
200 # and there appears to be a bug with vfio-pci
201   # if fdio on baremetal, then we are using UCS enic and
202   # need to use vfio-pci instead of uio generic
203 #  if [[ "$DEPLOY_SCENARIO" == *fdio* ]]; then
204 #    TMP_DEPLOY_FILE="${WORKSPACE}/${DEPLOY_SCENARIO}.yaml"
205 #    cp -f ${DEPLOY_FILE} ${TMP_DEPLOY_FILE}
206 #    sed -i 's/^\(\s*uio-driver:\).*$/\1 vfio-pci/g' ${TMP_DEPLOY_FILE}
207 #    DEPLOY_FILE=${TMP_DEPLOY_FILE}
208 #  fi
209
210   if ! sudo test -e "$INVENTORY_FILE"; then
211     echo "ERROR: Required settings file missing: Inventory settings file ${INVENTORY_FILE}"
212     exit 1
213   fi
214   # include inventory file for bare metal deployment
215   DEPLOY_CMD="${DEPLOY_CMD} -i ${INVENTORY_FILE}"
216 fi
217
218 if [ "$IPV6_FLAG" == "True" ]; then
219   NETWORK_FILE="${NETWORK_SETTINGS_DIR}/network_settings_v6.yaml"
220 elif echo ${DEPLOY_SCENARIO} | grep fdio; then
221   NETWORK_FILE="${NETWORK_SETTINGS_DIR}/network_settings_vpp.yaml"
222 else
223   NETWORK_FILE="${NETWORK_SETTINGS_DIR}/network_settings.yaml"
224 fi
225
226 # Check that network settings file exists
227 if ! sudo test -e "$NETWORK_FILE"; then
228   echo "ERROR: Required settings file missing: Network Settings file ${NETWORK_FILE}"
229   exit 1
230 fi
231
232 # start deployment
233 sudo ${DEPLOY_CMD} -d ${DEPLOY_FILE} -n ${NETWORK_FILE} --debug
234
235 if [[ "$JOB_NAME" == *csit* ]]; then
236   echo "CSIT job: setting host route for floating ip routing"
237   # csit route to allow docker container to reach floating ips
238   UNDERCLOUD=$(sudo virsh domifaddr undercloud | grep -Eo "[0-9\.]+{3}[0-9]+")
239   if sudo route | grep 192.168.37.128 > /dev/null; then
240     sudo route del -net 192.168.37.128 netmask 255.255.255.128
241   fi
242   sudo route add -net 192.168.37.128 netmask 255.255.255.128 gw ${UNDERCLOUD}
243 fi
244
245 echo
246 echo "--------------------------------------------------------"
247 echo "Done!"